%global momorel 2
%global md5sum_src0 4c6455d202cef35395a673386e4bf01a

Name:           chkrootkit
Version:        0.47
Release: %{momorel}m%{?dist}
Summary:        A tool to locally check for signs of a rootkit
Group:          Applications/System
License:        BSD
URL:            http://www.chkrootkit.org/
%NoSource 0     http://www.mirrors.wiretapped.net/security/host-security/%{name}/%{name}-%{version}.tar.gz %{md5sum_src0}
Source1:        %{name}X
Source2:        %{name}.png
Source3:        %{name}.desktop
Source4:        %{name}.console
Source5:        %{name}.pam
Patch1:         %{name}-0.44-getCMD.patch
Patch2:         %{name}-0.44-inetd.patch
Patch3:         %{name}-0.45-includes.patch
Patch4:         %{name}-%{version}-warnings.patch
Patch5:         %{name}-%{version}-no-openbsd.patch
Patch6:         %{name}-%{version}-chklastlog.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-root
Requires:       usermode
BuildRequires:  desktop-file-utils

%description
chkrootkit is a tool to locally check for signs of a rootkit. It contains:

 * chkrootkit: shell script that checks system binaries for rootkit
  modification. The following tests are made:

  o aliens asp bindshell lkm rexedcs sniffer wted scalper slapper z2 amd
    basename biff chfn chsh cron date du dirname echo egrep env find fingerd
    gpm grep hdparm su ifconfig inetd inetdconf init identd killall ldsopreload
    login ls lsof mail mingetty netstat named passwd pidof pop2 pop3 ps pstree
    rpcinfo rlogind rshd slogin sendmail sshd syslogd tar tcpd tcpdump top
    telnetd timed traceroute vdir w write 

 * ifpromisc.c: checks if the interface is in promiscuous mode.
 * chklastlog.c: checks for lastlog deletions.
 * chkwtmp.c: checks for wtmp deletions.
 * check_wtmpx.c: checks for wtmpx deletions. (Solaris only)
 * chkproc.c: checks for signs of LKM trojans.
 * chkdirs.c: checks for signs of LKM trojans.
 * strings.c: quick and dirty strings replacement. 


%prep
%setup -q -n %{name}-%{version}
%patch1 -p1 -b .getCMD
%patch2 -p1 -b .inetd
%patch3 -p1 -b .includes
%patch4 -p1 -b .warnings
%patch5 -p1 -b .no-openbsd
%patch6 -p1 -b .chklastlog

%build
make sense CC="%{__cc} %{optflags}"

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_sbindir}
cat << EOF > .tmp.chkrootkit.sbin
#! /bin/sh
cd %{_libdir}/%{name}-%{version}
./chkrootkit
EOF
install -p -D -m0755 .tmp.chkrootkit.sbin %{buildroot}%{_sbindir}/chkrootkit

mkdir -p %{buildroot}%{_bindir}
ln -s %{_bindir}/consolehelper %{buildroot}%{_bindir}/chkrootkit

install -p -D -m0755 %{SOURCE1} %{buildroot}%{_bindir}/chkrootkitX
perl -pi -e 's!/usr/bin!%{_bindir}!' %{buildroot}%{_bindir}/chkrootkitX
install -p -D -m0644 %{SOURCE2} %{buildroot}%{_datadir}/pixmaps/chkrootkit.png
install -p -D -m0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/security/console.apps/chkrootkit
perl -pi -e 's!/usr/sbin!%{_sbindir}!' %{buildroot}%{_sysconfdir}/security/console.apps/chkrootkit
install -p -D -m0644 %{SOURCE5} %{buildroot}%{_sysconfdir}/pam.d/chkrootkit
for f in \
    check_wtmpx  \
    chkdirs  \
    chklastlog  \
    chkproc  \
    chkrootkit  \
    chkutmp  \
    chkwtmp  \
    ifpromisc  \
    strings-static \
; do
    install -p -D -m0755 $f %{buildroot}%{_libdir}/%{name}-%{version}/${f}
done
ln -s strings-static %{buildroot}%{_libdir}/%{name}-%{version}/strings

desktop-file-install --vendor=""                    \
  --dir %{buildroot}%{_datadir}/applications      \
  --remove-category=Application \
  %{SOURCE3}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc ACKNOWLEDGMENTS COPYRIGHT README README.chklastlog README.chkwtmp chkrootkit.lsm
%{_sbindir}/chkrootkit
%{_bindir}/chkrootkit
%{_bindir}/chkrootkitX
%{_sysconfdir}/pam.d/chkrootkit
%{_sysconfdir}/security/console.apps/chkrootkit
%{_libdir}/%{name}-%{version}
%{_datadir}/applications/chkrootkit.desktop
%{_datadir}/pixmaps/chkrootkit.png

%changelog
* Mon Jun 18 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.47-2m)
- update chkrootkit.pam for new pam
- enable %%{optflags}

* Fri Jun  8 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (0.47-1m)
- update to 0.47 (sync with FC-devel)
- import patch3 - patch6 from FC

* Fri Sep 15 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.46a-2m)
- remove category Application

* Tue Nov  1 2005 Kazuhiko <kazuhiko@fdiary.net>
- (0.46a-1m)
- version up

* Fri Jul  8 2005 Kazuhiko <kazuhiko@fdiary.net>
- (0.45-2m)
- add chkutmp

* Sun Mar 21 2005 Kazuya Iwamoto <iwapi@momonga-linux.org>
- (0.45-1m)
- some bug fixes

* Thu Dec 16 2004 Kazuhiko <kazuhiko@fdiary.net>
- (0.44-2m)
- requires 'usermode' package instead of '%{_bindir}/consolehelper'

* Wed Dec 15 2004 Kazuya Iwamoto <iwapi@momonga-linux.org>
- (0.44-1m)
- import from fedora.us

* Mon Oct  4 2004 Michael Schwendt <mschwendt[AT]users.sf.net> - 0:0.44-0.fdr.2
- Fix inetd/sshd checks.

* Sat Sep 11 2004 Michael Schwendt <mschwendt[AT]users.sf.net> - 0:0.44-0.fdr.1
- Update to 0.44.
